<?php
// +----------------------------------------------------------------------
// | likeadmin快速开发前后端分离管理后台（PHP版）
// +----------------------------------------------------------------------
// | 欢迎阅读学习系统程序代码，建议反馈是我们前进的动力
// | 开源版本可自由商用，可去除界面版权logo
// | gitee下载：https://gitee.com/likeshop_gitee/likeadmin
// | github下载：https://github.com/likeshop-github/likeadmin
// | 访问官网：https://www.likeadmin.cn
// | likeadmin团队 版权所有 拥有最终解释权
// +----------------------------------------------------------------------
// | author: likeadminTeam
// +----------------------------------------------------------------------

namespace app\adminapi\logic\fault_type;


use app\common\model\fault_type\FaultType;
use app\common\logic\BaseLogic;
use think\facade\Db;


/**
 * FaultType逻辑
 * Class FaultTypeLogic
 * @package app\adminapi\logic
 */
class FaultTypeLogic extends BaseLogic
{
    public static function lists($params)
    {
        $where = [];
        if (!empty($params['name'])) {
            $where[] = ['name', 'like', '%' . $params['name'] . '%'];
        }
        if (isset($params['status']) && $params['status'] != '') {
            $where[] = ['status', '=', $params['status']];
        }
        $lists = FaultType::where($where)
            ->append(['status_desc'])
            ->order(['sort' => 'desc', 'id' => 'desc'])
            ->select()
            ->toArray();

        $pid = 0;
        if (!empty($lists)) {
            $pid = min(array_column($lists, 'pid'));
        }
        return self::getTree($lists, $pid);
    }
    public static function getTree($array, $pid = 0, $level = 0)
    {
        $list = [];
        foreach ($array as $key => $item) {
            if ($item['pid'] == $pid) {
                $item['level'] = $level;
                $item['children'] = self::getTree($array, $item['id'], $level + 1);
                $list[] = $item;
            }
        }
        return $list;
    }
    public static function leaderDept()
    {
        $lists = FaultType::field(['id', 'name'])->where(['status' => 1])
            ->order(['sort' => 'desc', 'id' => 'desc'])
            ->select()
            ->toArray();
        return $lists;
    }
    /**
     * @notes 添加
     * @param array $params
     * @return bool
     * @author likeadmin
     * @date 2024/10/18 15:09
     */
    public static function add(array $params): bool
    {
        Db::startTrans();
        try {
            FaultType::create([
                'name' => $params['name'],
                'pid' => $params['pid'],
                'sort' => $params['sort']?:0,
                //'level' => $params['level'],
                'status' => $params['status'],
            ]);

            Db::commit();
            return true;
        } catch (\Exception $e) {
            Db::rollback();
            self::setError($e->getMessage());
            return false;
        }
    }


    /**
     * @notes 编辑
     * @param array $params
     * @return bool
     * @author likeadmin
     * @date 2024/10/18 15:09
     */
    public static function edit(array $params): bool
    {
        Db::startTrans();
        try {
            $pid = $params['pid'];
            $oldFaultData = FaultType::findOrEmpty($params['id']);
            if ($oldFaultData['pid'] == 0) {
                $pid = 0;
            }
            FaultType::where('id', $params['id'])->update([
                'pid' => $pid,
                'name' => $params['name'],
                'sort' => $params['sort'],
                //'level' => $params['level'],
                'status' => $params['status'],
            ]);

            Db::commit();
            return true;
        } catch (\Exception $e) {
            Db::rollback();
            self::setError($e->getMessage());
            return false;
        }
    }


    /**
     * @notes 删除
     * @param array $params
     * @return bool
     * @author likeadmin
     * @date 2024/10/18 15:09
     */
    public static function delete(array $params): bool
    {
        return FaultType::destroy($params['id']);
    }


    /**
     * @notes 获取详情
     * @param $params
     * @return array
     * @author likeadmin
     * @date 2024/10/18 15:09
     */
    public static function detail($params): array
    {
        return FaultType::findOrEmpty($params['id'])->toArray();
    }

    public static function getAllData($search = 'all')
    {
        $data = FaultType::where('status',1)
            ->order(['sort'=> 'desc','id' => 'desc'])
            ->select()
            ->toArray();
        if($search == 'all'){
            return array_merge([[
                'id'=>0,
                'name'=>'无上级分类',
                'pid'=>0,
                'sort'=>0,
                'level'=>0,
                'status'=>1
            ]],empty($data)?[]:self::getTree($data, min(array_column($data, 'pid'))));
        }
        if($search == 'api'){
            return empty($data)?[]:self::getTree($data, min(array_column($data, 'pid')));
        }
        return [];
    }
}